/*
 * config_table.c
 *
 * 
 *
 * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/
#define R_PHASE \
0,   0,    0, 0,  0, 64, 0,  0, 0,  0,   0, 0, 0, 0, 0, 0, 0, 16,0, 0, 16, 0, 16, 0, \
16,  0,    16,0,  0,  0, 0,  0, 16, 0,  16, 0, 0, 0, 0, 0, 0, 16,0, 0,  0, 0, 0,  0, \
0,   0,    0, 0,  0, 64, 0,  0, 0,  0,   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 32, 0, \
16,-26,   16, 0,  26, 0, 26, 0, 16,-26, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0,  \
0,   0,    0, 0,  0, 64, 0,  0,  0,  0,  0, 0, 0, 0, 0, 0, 0, 32,0, 0, 0,  0, 0, 0, \
16, 26,   16, 0, -26, 0,-26, 0, 16, 26, 16, 0, 0, 0, 0, 0, 0, 32,0, 0, 0,  0, 0, 0,

#define GR_PHASE \
-8,  0,   -8, 0,  32,32, 32, 0, -8,  0, -8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
-10,32,  -10, 0,  0, 38,  0, 0, -10,32,-10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, \
0,   0,    0, 0, 32,  0, 32, 0, 0,   0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
-13,32,  -13, 0,  0, 51, 0,  0,-13, 32,-13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, \
-16, 0,  -16, 0, 32, 64, 32, 0, -16, 0,-16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
0,  32,    0, 0,  0,  0,  0, 0, 0,  32, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0,

#define GB_PHASE \
-8, 32,   -8, 0,  0, 32,  0, 0, -8, 32, -8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
-8, 0,    -8, 0, 32, 32, 32, 0, -8, 0,  -8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, \
-16,32,  -16, 0,  0, 64,  0, 0, -16,32, -16,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
0,  0,     0, 0, 29, 6,  29, 0,  0, 0,   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, \
0, 32,     0, 0,  0, 0,   0, 0,  0, 32,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, \
-13,0,   -13, 0, 32, 51, 32, 0, -13, 0,-13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0,

#define B_PHASE  \
16,-6,    16, 0, 6,  0,   6, 0, 16, -6, 16, 0, 0, 0, 0, 0, 0, 16,0, 0,16, 0, 16, 0, \
0,  0,     0, 0, 0, 64,   0, 0,  0,  0,  0, 0, 0, 0, 0, 0, 0, 16,0, 0, 0, 0,  0, 0, \
16, -32,  16, 0, 32, 0,  32, 0, 16, -32, 16,0, 0, 0, 0, 0, 0, 0, 0, 0, 32,0, 32, 0, \
0,  0,     0, 0, 0, 64,   0, 0,  0,  0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, \
16, 26,   16, 0,-26, 0, -26, 0, 16, 26, 16, 0, 0, 0, 0, 0, 0, 32, 0,0, 0, 0,  0, 0, \
0,  0,     0, 0, 0, 64,   0, 0, 0,   0,  0, 0, 0, 0, 0, 0, 0, 32, 0,0, 0, 0,  0, 0,

const char default_cfa_table[] = {
	GR_PHASE R_PHASE B_PHASE GB_PHASE
};

const unsigned char default_gamma_table[] = {
	0,
	1,
	2,
	3,
	4,
	5,
	5,
	6,
	7,
	8,
	9,
	10,
	11,
	12,
	13,
	13,
	14,
	15,
	16,
	17,
	18,
	19,
	20,
	21,
	21,
	22,
	23,
	24,
	25,
	26,
	27,
	28,
	29,
	29,
	30,
	31,
	32,
	33,
	34,
	35,
	36,
	37,
	37,
	38,
	39,
	40,
	41,
	42,
	43,
	44,
	45,
	45,
	46,
	47,
	48,
	49,
	50,
	51,
	52,
	53,
	53,
	54,
	55,
	56,
	57,
	58,
	59,
	60,
	61,
	61,
	62,
	63,
	64,
	65,
	66,
	67,
	68,
	68,
	69,
	70,
	71,
	72,
	73,
	74,
	75,
	76,
	76,
	77,
	78,
	79,
	80,
	81,
	82,
	83,
	84,
	84,
	85,
	86,
	87,
	88,
	88,
	89,
	89,
	90,
	90,
	90,
	91,
	91,
	92,
	92,
	93,
	93,
	93,
	94,
	94,
	95,
	95,
	95,
	96,
	96,
	96,
	97,
	97,
	98,
	98,
	98,
	99,
	99,
	99,
	100,
	100,
	101,
	101,
	101,
	102,
	102,
	102,
	103,
	103,
	103,
	104,
	104,
	105,
	105,
	105,
	106,
	106,
	106,
	107,
	107,
	107,
	108,
	108,
	108,
	109,
	109,
	109,
	110,
	110,
	110,
	111,
	111,
	111,
	112,
	112,
	112,
	112,
	113,
	113,
	113,
	114,
	114,
	114,
	115,
	115,
	115,
	116,
	116,
	116,
	117,
	117,
	117,
	117,
	118,
	118,
	118,
	119,
	119,
	119,
	119,
	120,
	120,
	120,
	121,
	121,
	121,
	122,
	122,
	122,
	122,
	123,
	123,
	123,
	124,
	124,
	124,
	124,
	125,
	125,
	125,
	125,
	126,
	126,
	126,
	127,
	127,
	127,
	127,
	128,
	128,
	128,
	128,
	129,
	129,
	129,
	130,
	130,
	130,
	130,
	131,
	131,
	131,
	131,
	132,
	132,
	132,
	132,
	133,
	133,
	133,
	133,
	134,
	134,
	134,
	134,
	135,
	135,
	135,
	136,
	136,
	136,
	136,
	137,
	137,
	137,
	137,
	137,
	138,
	138,
	138,
	138,
	139,
	139,
	139,
	139,
	140,
	140,
	140,
	140,
	141,
	141,
	141,
	141,
	142,
	142,
	142,
	142,
	143,
	143,
	143,
	143,
	143,
	144,
	144,
	144,
	144,
	145,
	145,
	145,
	145,
	146,
	146,
	146,
	146,
	146,
	147,
	147,
	147,
	147,
	148,
	148,
	148,
	148,
	149,
	149,
	149,
	149,
	149,
	150,
	150,
	150,
	150,
	151,
	151,
	151,
	151,
	151,
	152,
	152,
	152,
	152,
	152,
	153,
	153,
	153,
	153,
	154,
	154,
	154,
	154,
	154,
	155,
	155,
	155,
	155,
	155,
	156,
	156,
	156,
	156,
	157,
	157,
	157,
	157,
	157,
	158,
	158,
	158,
	158,
	158,
	159,
	159,
	159,
	159,
	159,
	160,
	160,
	160,
	160,
	160,
	161,
	161,
	161,
	161,
	161,
	162,
	162,
	162,
	162,
	162,
	163,
	163,
	163,
	163,
	163,
	164,
	164,
	164,
	164,
	164,
	165,
	165,
	165,
	165,
	165,
	166,
	166,
	166,
	166,
	166,
	167,
	167,
	167,
	167,
	167,
	168,
	168,
	168,
	168,
	168,
	168,
	169,
	169,
	169,
	169,
	169,
	170,
	170,
	170,
	170,
	170,
	171,
	171,
	171,
	171,
	171,
	171,
	172,
	172,
	172,
	172,
	172,
	173,
	173,
	173,
	173,
	173,
	173,
	174,
	174,
	174,
	174,
	174,
	175,
	175,
	175,
	175,
	175,
	175,
	176,
	176,
	176,
	176,
	176,
	177,
	177,
	177,
	177,
	177,
	177,
	178,
	178,
	178,
	178,
	178,
	179,
	179,
	179,
	179,
	179,
	179,
	180,
	180,
	180,
	180,
	180,
	180,
	181,
	181,
	181,
	181,
	181,
	181,
	182,
	182,
	182,
	182,
	182,
	183,
	183,
	183,
	183,
	183,
	183,
	184,
	184,
	184,
	184,
	184,
	184,
	185,
	185,
	185,
	185,
	185,
	185,
	186,
	186,
	186,
	186,
	186,
	186,
	187,
	187,
	187,
	187,
	187,
	187,
	188,
	188,
	188,
	188,
	188,
	188,
	189,
	189,
	189,
	189,
	189,
	189,
	190,
	190,
	190,
	190,
	190,
	190,
	191,
	191,
	191,
	191,
	191,
	191,
	191,
	192,
	192,
	192,
	192,
	192,
	192,
	193,
	193,
	193,
	193,
	193,
	193,
	194,
	194,
	194,
	194,
	194,
	194,
	195,
	195,
	195,
	195,
	195,
	195,
	195,
	196,
	196,
	196,
	196,
	196,
	196,
	197,
	197,
	197,
	197,
	197,
	197,
	197,
	198,
	198,
	198,
	198,
	198,
	198,
	199,
	199,
	199,
	199,
	199,
	199,
	199,
	200,
	200,
	200,
	200,
	200,
	200,
	201,
	201,
	201,
	201,
	201,
	201,
	201,
	202,
	202,
	202,
	202,
	202,
	202,
	202,
	203,
	203,
	203,
	203,
	203,
	203,
	204,
	204,
	204,
	204,
	204,
	204,
	204,
	205,
	205,
	205,
	205,
	205,
	205,
	205,
	206,
	206,
	206,
	206,
	206,
	206,
	206,
	207,
	207,
	207,
	207,
	207,
	207,
	207,
	208,
	208,
	208,
	208,
	208,
	208,
	209,
	209,
	209,
	209,
	209,
	209,
	209,
	210,
	210,
	210,
	210,
	210,
	210,
	210,
	211,
	211,
	211,
	211,
	211,
	211,
	211,
	211,
	212,
	212,
	212,
	212,
	212,
	212,
	212,
	213,
	213,
	213,
	213,
	213,
	213,
	213,
	214,
	214,
	214,
	214,
	214,
	214,
	214,
	215,
	215,
	215,
	215,
	215,
	215,
	215,
	216,
	216,
	216,
	216,
	216,
	216,
	216,
	217,
	217,
	217,
	217,
	217,
	217,
	217,
	217,
	218,
	218,
	218,
	218,
	218,
	218,
	218,
	219,
	219,
	219,
	219,
	219,
	219,
	219,
	219,
	220,
	220,
	220,
	220,
	220,
	220,
	220,
	221,
	221,
	221,
	221,
	221,
	221,
	221,
	222,
	222,
	222,
	222,
	222,
	222,
	222,
	222,
	223,
	223,
	223,
	223,
	223,
	223,
	223,
	223,
	224,
	224,
	224,
	224,
	224,
	224,
	224,
	225,
	225,
	225,
	225,
	225,
	225,
	225,
	225,
	226,
	226,
	226,
	226,
	226,
	226,
	226,
	226,
	227,
	227,
	227,
	227,
	227,
	227,
	227,
	228,
	228,
	228,
	228,
	228,
	228,
	228,
	228,
	229,
	229,
	229,
	229,
	229,
	229,
	229,
	229,
	230,
	230,
	230,
	230,
	230,
	230,
	230,
	230,
	231,
	231,
	231,
	231,
	231,
	231,
	231,
	231,
	232,
	232,
	232,
	232,
	232,
	232,
	232,
	232,
	233,
	233,
	233,
	233,
	233,
	233,
	233,
	233,
	234,
	234,
	234,
	234,
	234,
	234,
	234,
	234,
	235,
	235,
	235,
	235,
	235,
	235,
	235,
	235,
	236,
	236,
	236,
	236,
	236,
	236,
	236,
	236,
	237,
	237,
	237,
	237,
	237,
	237,
	237,
	237,
	237,
	238,
	238,
	238,
	238,
	238,
	238,
	238,
	238,
	239,
	239,
	239,
	239,
	239,
	239,
	239,
	239,
	240,
	240,
	240,
	240,
	240,
	240,
	240,
	240,
	240,
	241,
	241,
	241,
	241,
	241,
	241,
	241,
	241,
	242,
	242,
	242,
	242,
	242,
	242,
	242,
	242,
	243,
	243,
	243,
	243,
	243,
	243,
	243,
	243,
	243,
	244,
	244,
	244,
	244,
	244,
	244,
	244,
	244,
	245,
	245,
	245,
	245,
	245,
	245,
	245,
	245,
	245,
	246,
	246,
	246,
	246,
	246,
	246,
	246,
	246,
	246,
	247,
	247,
	247,
	247,
	247,
	247,
	247,
	247,
	248,
	248,
	248,
	248,
	248,
	248,
	248,
	248,
	248,
	249,
	249,
	249,
	249,
	249,
	249,
	249,
	249,
	249,
	250,
	250,
	250,
	250,
	250,
	250,
	250,
	250,
	250,
	251,
	251,
	251,
	251,
	251,
	251,
	251,
	251,
	251,
	252,
	252,
	252,
	252,
	252,
	252,
	252,
	252,
	253,
	253,
	253,
	253,
	253,
	253,
	253,
	253,
	253,
	254,
	254,
	254,
	254,
	254,
	254,
	254,
	254,
	254,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255,
	255
};

unsigned char default_noise_filter_table[] = {
	9,
	9,
	8,
	8,
	7,
	7,
	7,
	6,
	6,
	6,
	5,
	5,
	5,
	5,
	5,
	5,
	5,
	6,
	6,
	6,
	6,
	6,
	6,
	6,
	6,
	6,
	6,
	6,
	7,
	7,
	7,
	7,
	7,
	7,
	7,
	7,
	7,
	7,
	7,
	8,
	8,
	8,
	8,
	8,
	8,
	8,
	8,
	8,
	8,
	8,
	9,
	9,
	9,
	9,
	9,
	9,
	9,
	9,
	9,
	9,
	9,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	10,
	11,
	11,
	11,
	11,
	11,
	11,
	11,
	11,
	11,
	11,
	11,
	12,
	12,
	12,
	12,
	12,
	12,
	12,
	12,
	12,
	12,
	12,
	13,
	13,
	13,
	13,
	13,
	13,
	13,
	13,
	13,
	13,
	13,
	14,
	14,
	14,
	14,
	14,
	14,
	14,
	14,
	14,
	14,
	14,
	15,
	15,
	15,
	15,
	15,
	15,
	15,
	15,
	15,
	15,
	15,
	16,
	16,
	16,
	16,
	16,
	16,
	16,
	16,
	16,
	16,
	16,
	17,
	17,
	17,
	17,
	17,
	17,
	17,
	17,
	17,
	17,
	17,
	18,
	18,
	18,
	18,
	18,
	18,
	18,
	18,
	18,
	18,
	18,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	19,
	20,
	20,
	20,
	20,
	20,
	20,
	20,
	20,
	20,
	20,
	20,
	21,
	21,
	21,
	21,
	21,
	21,
	21,
	21,
	21,
	21,
	21,
	22,
	22,
	22,
	22,
	22,
	22,
	22,
	22,
	22,
	22,
	22,
	23,
	23,
	23,
	23,
	23,
	23,
	23,
	23,
	23,
	23,
	23,
	24,
	24,
	24,
	24,
	24,
	24,
	24,
	24,
	24,
	24,
	24,
	25,
	25,
	25,
	25,
	25,
	25,
	25,
	25,
	25,
	25,
	25,
	26,
	26,
	26,
	26,
	26,
	26,
	26,
	26,
	26,
	26,
	26,
	27,
	27,
	27,
	27,
	27,
	27
};

const unsigned int default_luma_enhancement_table[] = {
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1047552,
	1048575,
	1047551,
	1046527,
	1045503,
	1044479,
	1043455,
	1042431,
	1041407,
	1040383,
	1039359,
	1038335,
	1037311,
	1036287,
	1035263,
	1034239,
	1033215,
	1032191,
	1031167,
	1030143,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028096,
	1028100,
	1032196,
	1036292,
	1040388,
	1044484,
	0,
	0,
	0,
	5,
	5125,
	10245,
	15365,
	20485,
	25605,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	30720,
	31743,
	30719,
	29695,
	28671,
	27647,
	26623,
	25599,
	24575,
	23551,
	22527,
	21503,
	20479,
	19455,
	18431,
	17407,
	16383,
	15359,
	14335,
	13311,
	12287,
	11263,
	10239,
	9215,
	8191,
	7167,
	6143,
	5119,
	4095,
	3071,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024,
	1024
};
